Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus, lNetComponents, lNet;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    UDP_Server: TLUDPComponent;
    UDP_Client: TLUDPComponent;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure UDP_ClientError(Const msg: String; aSocket: TLSocket);
    Procedure UDP_ClientReceive(aSocket: TLSocket);
    Procedure UDP_ServerError(Const msg: String; aSocket: TLSocket);
    Procedure UDP_ServerReceive(aSocket: TLSocket);
    Procedure MenuItem1Click(Sender: TObject);
    Procedure MenuItem2Click(Sender: TObject);
  private
  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }
Uses
  uip;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  (*
   * Historie: 0.01 = Initialversion
   *           0.02 = first version that works
   *)
  caption := 'Network finder ver. 0.02';
  Memo1.Clear;
  Memo2.Clear;
  Memo3.Clear;
  edit1.text := '9876';
  edit3.text := '9876';
  edit2.text := 'Hello its me the server';
  edit4.text := 'Hello its me the client';
End;

Procedure TForm1.UDP_ClientError(Const msg: String; aSocket: TLSocket);
Begin
  memo3.Lines.Add('Client error: ' + msg);
  memo3.SelStart := length(Memo3.Text) + 1;
End;

Procedure TForm1.UDP_ClientReceive(aSocket: TLSocket);
Var
  Buf: Array[0..1023] Of Byte;
  cnt, i: Integer;
  s: String;
Begin
  If Not assigned(aSocket) Then exit;
  cnt := aSocket.Get(buf, 1024); // Lesen der Antwort des Servers ;-)
  s := '';
  setlength(s, cnt);
  For i := 0 To cnt - 1 Do Begin
    s[i + 1] := chr(buf[i]);
  End;
  memo3.Lines.add('Got "' + s + '" on:' + aSocket.LocalAddress + ' from ' + aSocket.PeerAddress);
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
Begin
  If UDP_Client.Connected Then Begin
    UDP_Client.Disconnect(true);
  End;
  If UDP_Server.Connected Then Begin
    UDP_Server.Disconnect(true);
  End;
End;

Procedure TForm1.Button1Click(Sender: TObject);
Var
  N: TNetworkAdapterList;
  i: Integer;
Begin
  n := GetLocalIPs();
  Memo1.Clear;
  For i := 0 To high(n) Do Begin
    Memo1.Lines.Add(n[i].AdapterName + ': ' + n[i].IpAddress + ' Mask: ' + n[i].SubnetMask);
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  // Start / Stop Server
  Memo2.Clear;
  If Button2.Caption = 'Stop server' Then Begin
    UDP_Server.Disconnect(true);
    Button2.caption := 'Start server';
    Memo2.lines.add('Server stopped.');
  End
  Else Begin
    UDP_Server.ReuseAddress := true;
    If UDP_Server.Listen(strtoint(edit1.text)) Then Begin
      Button2.Caption := 'Stop server';
      Memo2.Lines.Add('Start listen on:' + Edit1.Text);
    End
    Else Begin
      ShowMessage('Error, could not start server.');
    End;
  End;
End;

Procedure TForm1.Button3Click(Sender: TObject);
Var
  N: TNetworkAdapterList;
  i: Integer;
  s: String;
Begin
  // Poll via Adapter
  memo3.clear;
  If UDP_Client.Connected Then Begin
    UDP_Client.Disconnect(true);
  End;
  n := GetLocalIPs();
  Memo3.Lines.Add('Started poll on ' + inttostr(length(n)) + ' adapters.');

  UDP_Client.ReuseAddress := true;
  For i := 0 To high(n) Do Begin
    If UDP_Client.Connect('127.0.0.1', StrToInt(Edit3.text)) Then Begin
      s := CalculateBroadCastAddressFromAddress(n[i].IpAddress, n[i].SubnetMask);
      UDP_Client.SendMessage(Edit4.Text, s);
    End
    Else Begin
      memo3.lines.add('Error could not start UDP-Connection on adapter: ' + N[i].AdapterName);
    End;
  End;
End;

Procedure TForm1.Button4Click(Sender: TObject);
Begin
  close;
End;

Procedure TForm1.Button5Click(Sender: TObject);
Begin
  // Poll via Broadcast
  memo3.clear;
  If UDP_Client.Connected Then Begin
    UDP_Client.Disconnect(true);
  End;
  Memo3.Lines.Add('Started poll via localhost');
  UDP_Client.ReuseAddress := true;
  If UDP_Client.Connect('127.0.0.1', StrToInt(Edit3.text)) Then Begin
    UDP_Client.SendMessage(Edit4.Text, LADDR_BR);
  End
  Else Begin
    memo3.lines.add('Error could not start UDP-Connection on 127.0.0.1');
  End;
End;

Procedure TForm1.UDP_ServerError(Const msg: String; aSocket: TLSocket);
Begin
  memo2.Lines.Add('Server error: ' + msg);
  memo2.SelStart := length(Memo2.Text) + 1;
End;

Procedure TForm1.UDP_ServerReceive(aSocket: TLSocket);
Var
  Buf: Array[0..1023] Of Byte;
  cnt, i: Integer;
  s: String;
Begin
  If Not assigned(aSocket) Then exit;
  cnt := aSocket.Get(buf, 1024); // Irgend etwas lesen damit aSocket die anderen Felder initialisiert;
  s := '';
  setlength(s, cnt);
  For i := 0 To cnt - 1 Do Begin
    s[i + 1] := chr(buf[i]);
  End;
  memo2.Lines.add('Got "' + s + '" on:' + aSocket.LocalAddress + ' from ' + aSocket.PeerAddress);
  s := Edit2.Text;
  For i := 0 To length(s) - 1 Do Begin
    buf[i] := ord(s[i + 1]);
  End;
  // Und ne kleine Nachricht zurück
  aSocket.Send(buf, length(s));
End;

Procedure TForm1.MenuItem1Click(Sender: TObject);
Begin
  memo2.clear;
End;

Procedure TForm1.MenuItem2Click(Sender: TObject);
Begin
  memo3.clear;
End;

End.

